#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <mem.h>
#include "systable.h"

#define SEARCH_LENGTH   0x8000

void find_sign (unsigned segm, unsigned offs, char *signature)
{
    char     *address;
    int      i, found = 0;
    unsigned search_length;

    search_length = SEARCH_LENGTH;
    address = MK_FP (segm, offs);

    while ((FP_OFF(address) < offs + SEARCH_LENGTH - 1) & (!found))
        {
        if ((address = memchr (address, '(', search_length)) != NULL)
            {
            if ((i = memicmp (address, "(C)", 3)) == 0)
                {
                found = 1;
                }
            else
                {
                search_length = (unsigned)32767 - FP_OFF (address) - 1;
                address = MK_FP (FP_SEG (address), FP_OFF (address) + 1);
                }
            }
        else
            {
            found = -1;
            }
        }

    if (i != 0)
        {
        search_length = SEARCH_LENGTH;
        address = MK_FP (segm, offs);

        while ((FP_OFF(address) < offs + SEARCH_LENGTH) & (!found))
            {
            if ((address = memchr (address, 'C', search_length)) != NULL)
                {
                if ((i = memicmp (address, "COPYRIGHT", 9)) == 0)
                    {
                    found = 1;
                    }
                else
                    {
                    search_length = (unsigned)32767 - FP_OFF (address) - 1;
                    address = MK_FP (FP_SEG (address), FP_OFF (address) + 1);
                    }
                }
            else
                {
                found = -1;
                }

            }
        }

    if (i != 0)
        {
        search_length = SEARCH_LENGTH;
        address = MK_FP (segm, offs);

        while ((FP_OFF(address) < offs + SEARCH_LENGTH) & (!found))
            {
            if ((address = memchr (address, 'C', search_length)) != NULL)
                {
                if ((i = memicmp (address, "COPR", 4)) == 0)
                    {
                    found = 1;
                    }
                else
                    {
                    search_length = (unsigned)32767 - FP_OFF (address) - 1;
                    address = MK_FP (FP_SEG (address), FP_OFF (address) + 1);
                    }
                }
            else
                {
                found = -1;
                }
            }   
        }

    if (i != 0)
        {
        search_length = SEARCH_LENGTH;
        address = MK_FP (segm, offs);

        while ((FP_OFF(address) < offs + SEARCH_LENGTH) & (!found))
            {
            if ((address = memchr (address, 'I', search_length)) != NULL)
                {
                if ((i = memicmp (address, "IBM", 3)) == 0)
                    {
                    found = 1;
                    }
                else
                    {
                    search_length = (unsigned)32767 - FP_OFF (address) - 1;
                    address = MK_FP (FP_SEG (address), FP_OFF (address) + 1);
                    }
                }
            else
                {
                found = -1;
                }

            }
        }

    if (i == 0)
        {
        memset (signature, '\0', MAX_SIGNATURE);
        memccpy(signature, address, '\0', MAX_SIGNATURE - 1);
        for (i = 0; i < MAX_SIGNATURE; i++)
            {
            if ((unsigned)signature[i] < 0x7F)
                {
                if (!isprint (signature[i]))
                    {
                    signature [i] = '\0';
                    i = MAX_SIGNATURE;
                    }
                }
            else
                {
                signature [i] = '\0';
                i = MAX_SIGNATURE;
                }
            }
        }
    else
        {
        strcpy (signature, "Signature not found");
        }
}
