#include <dos.h>

int ems_ok (unsigned char errval)

#define EMM_Err_soft     0x80  /* EMS software internal error */
#define EMM_Err_hard     0x81  /* EMS hardware error */
#define EMM_Err_undef    0x82  /* Undefined function request error */

{
   switch (errval)
   {
      case EMM_Err_soft:  printf ("\nEMS Software Error");
                          break;
      case EMM_Err_hard:  printf ("\nEMS Hardware Error");
                          break;
      case EMM_Err_undef: printf ("\nEMS Undefined Function Error");
                          break;
      default:            return (1); /* Return TRUE, EMS OK */
   }
   return (0);           /* Return FALSE, EMS not OK */
}

int farcmp (str1, str2, n)

char  far   *str1;
char  far   *str2;
int         n;
{
   while (*str2 && n > 0)
   {
      if (*str1 != *str2) return (0);             /* FALSE */
          n--;
      str1++;
      str2++;
   }
   return (1);                                    /* TRUE */
}

int ext_memory ()
{
   union REGS  regs;

        regs.h.ah = 0x88;       /* get extended memory size */
        int86 (0x15, &regs, &regs);
        if (regs.h.ah & 0x80)
                  return (0);
        else return (regs.x.ax);
}

int exp_memory (struct LIM_EMS *lim_ems)

#define EMM_int          0x67  /* EMMXXXX0 interrupt number */
#define EMM_stat         0x40  /* Get manager status function */
#define EMM_count        0x42  /* Get page counts function */
#define EMM_get_ver      0x46  /* Get driver version number */

{
   union  REGS   regs;
   struct SREGS  sregs;
   char   far    *emptr;
   char   far    *nameptr;
   long          testval;

   nameptr = "EMMXXXX0";
   regs.h.ah = 0x35;              /* Get interrupt vector */
   regs.h.al = 0x67;              /* Get it for the EMM driver */
   intdosx (&regs, &regs, &sregs);

   emptr = MK_FP (sregs.es, 0);

   if (!farcmp (emptr+10, nameptr, 8))
      {
      lim_ems->version = 0;
      lim_ems->free = 0;
      lim_ems->total = 0;
      return (0);
      }
   else
   {
      regs.h.ah = EMM_stat;       /* get manager status */
      intdosx (&regs, &regs, &sregs);
      if (ems_ok(regs.h.ah))
      {
         regs.h.ah = EMM_get_ver; /* get EMM version number */
         intdosx (&regs, &regs, &sregs);
         if (ems_ok(regs.h.ah))
         {
            lim_ems->version = regs.h.al;
            regs.h.ah = EMM_count;   /* get EMM page counts */
            intdosx (&regs, &regs, &sregs);
            if (ems_ok(regs.h.ah))
            {
               lim_ems->free  = regs.x.bx;  /* number of free 16K pages */
               lim_ems->total = regs.x.dx;  /* total number of 16K pages */
            }
         }
      }
   }
   return (1);
}
