#include <math.h>
#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "systables.h"
#include "memory.h"

#define TRUE    1
#define FALSE   !TRUE

int  enh_kb ();                                 /* Declared in KEYBOARD.C */
void video_info (struct VIDEO *);               /* Declared in VIDEO.C    */
int  GETCPU ();                                 /* Declared in GETCPU.ASM */
void bios_info (struct BIOS *bios);             /* Declared in BIOS.C */

int sys_config ()

    {
    unsigned char   abyte;
    union    REGS   inregs, outregs;
    struct   SREGS  segregs;
    struct   SDT    *sdt;
    struct   BIOS   bios;
    struct   VIDEO  video;
    struct   CVT    *cvt;
    void            *address;
    unsigned        segm, offs;
    union
        {
        struct   EQUIP  equip;
        int             int_equip;
        } equip_list;
    struct LIM_EMS  lim_ems;
    int             is_AT = FALSE;
    int             ext_mem, maxbps;
    char            keyboard[9], type[16], bus[35], vmode[15];
    int             floppies;
    char            cpu[6], ndp[6];
    double          result;
    char            rt_clock [4];

    switch (GETCPU())
        {
        case 88:    strcpy (cpu, "8088");
                    break;
        case 86:    strcpy (cpu, "8086");
                    break;
        case 186:   strcpy (cpu, "80186");
                    break;
        case 286:   strcpy (cpu, "80286");
                    break;
        case 386:   strcpy (cpu, "80386");
                    break;
        case 486:   strcpy (cpu, "80486");
                    break;
        default:    strcpy (cpu, "Unk.");
                    break;
        }

    result = pow10 (1);

    switch (_8087)
        {
        case 1:     strcpy (ndp, "8087");
                    break;
        case 2:     strcpy (ndp, "80287");
                    break;
        case 3:     strcpy (ndp, "80387");
                    break;
        default:    strcpy (ndp, "N/A");
                    break;
        }

    bios_info (&bios);
    ext_mem = ext_memory();
    exp_memory (&lim_ems);
    equip_list.int_equip = biosequip();

    printf (
"\n͸"
"\n BIOS Date: %8s  MS-DOS Version %1d.%2d  %17s Architecture  "
"\nĴ"
"\n %-76s"
"\n͵"
"\n Memory  Ports  CPU/Type "
"\nĴ"
"\n Base:      %4dKB  COM1: %4s  LPT1: %4s  Game   CPU:            %5s "
"\n Extended:  %4dKB  COM2: %4s  LPT2: %4s ͵ Co-Processor:   %5s "
"\n Expanded:  %4dKB  COM3: %4s  LPT3: %4s   %3s   Type: %15s "
"\n                    COM4: %4s  LPT4: %4s                               "
"\n;",
    bios.date,
    _osmajor,
    (_osminor < 10 ? _osminor * 10 : _osminor),
    bios.bus,
    bios.sign,
    biosmemory (),
    bios.com1,
    bios.lpt1,
    cpu,
    ext_mem,
    bios.com2,
    bios.lpt2,
    ndp,
    lim_ems.total * 16,     /* 16KB pages */
    bios.com3,
    bios.lpt3,
    (equip_list.equip.game ? "Yes" : "No "),
    bios.sysid_char,
    bios.com4,
    bios.lpt4);

    video_info (&video);

    strcpy (keyboard, enh_kb() ? "Enhanced" : "Standard");

    floppies = equip_list.equip.drives + 1;
    switch (equip_list.equip.video)
        {
        case 1: strcpy (vmode, "40 x 25 color");
                break;
        case 2: strcpy (vmode, "80 x 25 color");
                break;
        case 3: strcpy (vmode, "80 x 25 mono");
                break;
        }

    inregs.h.ah = 0x52;                            /* Get CVT base address */
    intdosx (&inregs, &outregs, &segregs);        /* call DOS */
    cvt = MK_FP(segregs.es, outregs.x.bx-8);    /* make it a far pointer */

    maxbps = cvt->maxbps;

    if (cvt->clock == NULL)
        strcpy (rt_clock, " No");
    else
        strcpy (rt_clock, "Yes");

    printf (
"\n͸"
"\n Feature Information "
"\n͵"
"\n Real Time Clock:       %3s  Keyboard: %8s  Number Floppy Drives:  %2d "
"\n Second Interrupt Chip:%4s  Int 0x09:     %4s  Number Fixed Drives:   %2d ",
    rt_clock,
    keyboard,
    bios.n_floppies,
    bios.chip2,
    bios.int09,
    bios.n_fixed_disks);

    printf (
"\nĴ"
"\n Video Adapter:      %20s  Wait for External Event:  %6s "
"\n Init. Video Mode:   %20s  Maximum Sector Size:      %6d "
"\n;",
    video.adapter,
    bios.ext_wait,
    vmode,
    maxbps);

    printf (
"\n͸"
"\n Video ROM BIOS Extension Signature "
"\nĴ"
"\n %-75s "
"\n͵"
"\n Hard Disk ROM BIOS Extension Signature "
"\nĴ"
"\n %-75s "
"\n;",
    video.sign,
    bios.hard_disk_sign);

    return (floppies);
    }
