#include <graphics.h>
#include <stdio.h>

#include "systable.h"

void find_sign (unsigned, unsigned, char *);

void video_info (struct VIDEO *video)
    {
    int graphdriver;
    int graphmode;

    detectgraph (&graphdriver, &graphmode);

    if (graphmode < 0)
        {
        strcpy (video->adapter, "MDA");
        strcpy (video->sign, "MDA is supported by the native BIOS; "
                             "extension not necessary");
        }
    else
        {
        switch (graphdriver)
            {
            case CGA:       strcpy (video->adapter, "CGA");
                            strcpy (video->sign, "CGA is supported by the native "
                                                 "BIOS; extension not necessary");
                            break;
            case MCGA:      strcpy (video->adapter, "MCGA");
                            strcpy (video->sign, "MCGA is supported by the native "
                                                 "BIOS; extension not necessary");
                            break;
            case EGA:       strcpy (video->adapter, "EGA 128K or More");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            case EGA64:     strcpy (video->adapter, "EGA 64K");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            case EGAMONO:   strcpy (video->adapter, "EGA Monochrome");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            case IBM8514:   strcpy (video->adapter, "IBM 8514");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            case HERCMONO:  strcpy (video->adapter, "Hercules Monochrome");
                            find_sign (0xC800, 0x0000, video->sign);
                            break;
            case ATT400:    strcpy (video->adapter, "AT&T 640 X 400");
                            find_sign (0xC800, 0x0000, video->sign);
                            break;
            case VGA:       strcpy (video->adapter, "VGA");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            case PC3270:    strcpy (video->adapter, "3270 PC");
                            find_sign (0xC000, 0x0000, video->sign);
                            break;
            default:        strcpy (video->adapter, "Unknown");
                            strcpy (video->sign, "Unknown");
                            break;
            }
        }
    }
